/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <map>

using namespace std;

int main()
{
    ifstream input ("village.in", ios::in);
    if (!input )
    {
        cout << "No input file" << endl;
        return 1;
    }

    int n, tmp;
    input >> n;
    //vector<int> sportsmen;
    map<int, int> wants;
    map<int, bool> used;
    map<int, bool> satisfied;
    for (int i = 1; i < n+1; i++)
    {
        input >> tmp;
        //sportsmen.push_back(i);
        wants[i] = tmp;
        used[i] = false;
        satisfied[i] = false;
    }

    for (int i = 1; i < n+1; i++)
    {
        if (!used[i] and !used[wants[i]] and (wants[wants[i]] == i))
        {
            cout << i << " and " << wants[i] << endl;
            satisfied[i] = true;
            satisfied[wants[i]] = true;
            used[i] = true;
            used[wants[i]] = true;
        }
    }

    for (int i = 1; i < n+1; i++)
    {
        if (!used[i] and !used[wants[i]])
        {
            used[i] = true;
            used[wants[i]] = true;
            satisfied[i] = true;
        }
    }

    int sum = 0;
    for (int i = 1; i < n+1; i++)
    {
        if (satisfied[i])
            sum += 1;
    }
    ofstream output ("village.out", ios::out);
    output << sum << endl;
    output.close();
    return 0;

}
