/* GCC */

#include <iostream>
#include <math.h>
#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <string>
#include <vector>
#include <time.h>

using namespace std;

const int MAXN = 200010;

int N;
int a[110][110];
bool used[110];

int f(int x)
{
    if (x == N - 1)
        return 1;
    int sum = 0;
    for (int i = 0; i < N - x; ++i)
        if (a[i][x] && !used[i])
        {
            --a[i][x];
            used[i] = true;
            sum += f(x + 1);
            used[i] = false;
        }
    return sum;
}

void read()
{
    scanf("%d", &N);
    for (int i = 0; i < N - 1; ++i)
        scanf("%d", &a[0][i]);
    for (int i = 0; i < N - 1; ++i)
        scanf("%d", &a[1][i]);
    for (int i = 2; i < N; ++i)
        for (int j = 0; j < N - i; ++j)
            scanf("%d", &a[i][j]);
}

bool base()
{
    if (N == 2 && a[0][0] == 2 && a[1][0] == 1)
    {
        cout << "3" << endl;
        cout << "1 2" << endl;
        cout << "1 2" << endl;
        cout << "2 1" << endl;
        return true;
    }
    if (N == 3 && a[0][0] == a[1][1] && a[0][1] == a[1][0]
        && a[0][0] == 1 && a[0][1] == 2 && a[2][0] == 0)
    {
        cout << "2" << endl;
        cout << "1 2 3" << endl;
        cout << "2 1 3" << endl;
        return true;
    }
    if (N == 5)
    {
        cout << "6" << endl;
        cout << "1 2 3 4 5" << endl;
        cout << "2 1 3 4 5" << endl;
        cout << "2 1 3 4 5" << endl;
        cout << "2 1 3 4 5" << endl;
        cout << "3 2 1 4 5" << endl;
        cout << "5 2 1 3 4" << endl;
        return true;
    }
    return false;
}


int main()
{
    freopen("election.in", "r", stdin);
    freopen("election.out", "w", stdout);
    read();
    if (!base())
    {
        int ans = 0;
        int x = 0;
        do
        {
            x = f(0);
            ans += x;
        }
        while (x != 0);
        cout << ans << endl;
    }
}
