/* GCC */
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <string>
#include <vector>
#include <time.h>

using namespace std;

const int MAXN = 1000010;

int N, sz, cur, ans;
int fz, lz, fo, lo;
int a[MAXN], z[MAXN], o[MAXN];
int q1[MAXN], q2[MAXN];


int get1()
{
    int ans = 0;
    for (int i = 1; i <= N; ++i)
        for (int j = i + ans + 1; j <= N; j += 2)
            if (z[j] - z[i - 1] == o[j] - o[i - 1])
                ans = max(ans, j - i + 1);
    return ans;
}

void go(int i)
{
    if (!sz)
    {
        q1[sz] = a[i];
        q2[sz++] = cur;
        ans = max(ans, cur);
        cur = 0;
    }
    else
    {
        if (a[i] != q1[sz - 1])
        {
            cur += 2;
            cur += q2[sz - 1];
            --sz;
        }
        else
        {
            q1[sz] = a[i];
            q2[sz] = cur;
            ++sz;
            ans = max(ans, cur);
            cur = 0;
        }
    }
}

void go2(int i)
{
    if (!sz)
    {
        q1[sz] = a[i];
        q2[sz++] = cur;
        ans = max(ans, cur);
        cur = 0;
    }
    else
    {
        if (a[i] != q1[sz - 1])
        {
            cur += 2;
            cur += q2[sz - 1];
            --sz;
        }
        else
        {
            q1[sz] = a[i];
            q2[sz] = 0;
            q2[sz - 1] += cur;
            ++sz;
            ans = max(ans, cur);
            cur = 0;
        }
    }
}

int get2()
{
    ans = 0;
    for (int t = 1; t <= 2; ++t)
    {
        cur = 0;
        sz = 0;
        for (int i = t; i <= N; ++i)
            go(i);
        ans = max(ans, cur);
    }

    for (int t = 0; t < 2; ++t)
    {
        cur = 0;
        sz = 0;
        for (int i = N - t; i > 0; --i)
            go(i);
        ans = max(ans, cur);
    }

    for (int t = 1; t <= 2; ++t)
    {
        cur = 0;
        sz = 0;
        for (int i = t; i <= N; ++i)
            go2(i);
        ans = max(ans, cur);
    }

    for (int t = 0; t < 2; ++t)
    {
        cur = 0;
        sz = 0;
        for (int i = N - t; i > 0; --i)
            go2(i);
        ans = max(ans, cur);
    }
    return ans;
}

int main()
{
    freopen("skiing.in", "r", stdin);
    freopen("skiing.out", "w", stdout);

    scanf("%d", &N);
    for (int i = 1; i <= N; ++i)
    {
        scanf("%d", &a[i]);
        z[i] = z[i - 1] + (a[i] ? 0 : 1);
        o[i] = o[i - 1] + a[i];
    }

    if (N < 20000)
        printf("%d\n", get1());
    else
        printf("%d\n", get2());
    return 0;
}
