/* GCC */
//#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef unsigned int uint;

struct request {
    vector<uint> v;
    uint permc;
};
vector<request> rqs;
vector<request> delch;
uint del_all = 0, del_perm = 0;

void get_del_all();
void get_del_perm();
uint minof(request &rq);

int main()
{
    uint reqs;
    ifstream ifs("election.in");
    ifs >> reqs;
    //cout << reqs << endl;

    rqs.reserve(reqs);
    --reqs;
    {
        request r;
        for(uint i = 0; i < reqs; ++i) {
            uint c;
            ifs >> c;
            //cout << c << " ";
            r.v.push_back(c);
        }
        //cout << endl;
        rqs.push_back(r);
    }
    for(; reqs > 0; --reqs) {
        request r;
        for(uint i = 0; i < reqs; ++i) {
            uint c;
            ifs >> c;
//            cout << c << " ";
            r.v.reserve(reqs);
            r.v.push_back(c);
        }
        //cout << endl;
        rqs.push_back(r);
    }
    ifs.close();

    get_del_all();
    get_del_perm();
    ofstream ofs("election.out");
    ofs << del_perm;
    ofs.close();
}

void get_del_all() {
    del_all = rqs[0].v[rqs.size()-2] + rqs[1].v[rqs.size()-2];
    //cout << "Del all = " << del_all << endl;
}

void get_del_perm() {
    del_perm = 0;
    for(uint i = 0; i < rqs.size(); ++i) {
        request& r = rqs[i];
        uint min = r.v[0];
        for(uint t = 1; t < r.v.size(); ++t) {
            if(r.v[t] < min) min = r.v[t];
        }
        r.permc = min;
        del_perm += min;
    }
    //cout << "Del perm = " << del_perm << endl;
}

void get_delch() {
    //request first;
}

uint minof(request &rq) {
    uint min = rq.v[0];
    for(uint t = 1; t < rq.v.size(); ++t) {
        if(rq.v[t] < min) min = rq.v[t];
    }
    return min;
}

