/* GCC */
#include <set>
#include <queue>
#include <vector>
#include <string>
#include <math.h>
#include <iostream>
#include <algorithm>

#define Ri(a) scanf("%d", &(a))
#define Ri2(a, b) scanf("%d%d", &(a), &(b))
#define Wi(a) printf("%d ", (a))
#define Wi2(a, b) printf("%d %d ", (a), (b))
#define Wie(a) printf("%d\n", (a))
#define Wie2(a, b) printf("%d %d\n", (a), (b))
#define pb push_back
#define mp make_pair
#define INF 1000000000
#define pause system("pause")
#define FOR(i,a,b) for( int (i) = (a), __n = (b); (i) <= __n; (i)++ )
#define FORD(i,a,b) for( int (i) = (a), __n = (b); (i) >= __n; (i)-- )
#define forn(i,n) FOR(i,0,n-1)
#define FILE

using namespace std;

int help[200010];
int dp[2][200010], dp1[2][200010], dp2[2][200010];

int n, t;
int used[200010];
vector < int > gr[200010];
vector < vector < int > > cycl;
vector < int > gr1[200000];
vector < int > gr2[200000];
vector < int > imp1, imp2;

void calk( int v )
{
     if( dp[v][0] != -200000 ) return;
     int sum = 0;
     
     forn( i, gr[v].size() )
     {
           calk( gr[v][i] );
           sum += max( dp[gr[v][i]][0], dp[gr[v][i]][1] );
     }
     dp[v][0] = sum;
     int mx = -200000;
     forn( i, gr[v].size() )
     {
           sum -= max( dp[gr[v][i]][0], dp[gr[v][i]][1] );
           sum += dp[gr[v][i]][0] + 1;
           mx = max( sum, mx );
           sum -= dp[gr[v][i]][0] + 1;
           sum += max( dp[gr[v][i]][0], dp[gr[v][i]][1] );
     }
     dp[v][1] = mx;
     return;
}

void calk2( int v )
{
     if( used[v] ) return;
     used[v] = 1;
     
     dp1[v][0] += max( dp1[gr1[v][0]][0], dp1[gr1[v][0]][1] );
     dp1[v][1] += max( dp1[v][1] + max( dp1[gr1[v][0]][0], dp1[gr1[v][0]][1] ), dp1[v][0] + dp1[gr1[v][0]][0] + 1 );
     return;
}

void calk2_(int v)
{
     if( used[v] ) return;
     used[v] = 1;
     
     dp2[v][0] += max( dp2[gr2[v][0]][0], dp2[gr2[v][0]][1] );
     dp2[v][1] += max( dp2[v][1] + max( dp2[gr2[v][0]][0], dp2[gr2[v][0]][1] ), dp2[v][0] + dp2[gr2[v][0]][0] + 1 );
     return;
}

bool find( int v )
{
     used[v] = t;
     forn( i, gr[v].size() )
     {
           if( used[gr[v][i]] == t )
           {
               cycl.resize( cycl.size() + 1 );
               cycl[cycl.size() - 1].pb( v );
               return 1;
           }
           if( find( gr[v][i] ) )
           {
               cycl[cycl.size() - 1].pb(v);
               return 1;
           }
     }
     return 0;
}

int main()
{
    #ifdef FILE
    freopen("village.in", "r", stdin);
    freopen("village.out", "w", stdout);
    #endif
    
    int a;
    Ri(n);
    forn( i, n )
    {
          Ri( a );
          help[i] = a - 1;
          gr[a - 1].pb(i);
    }
    memset( used, 0, n << 2 );
    cycl.reserve(n);
    
    t = 0;
    forn( i, n )
          if( !used[i] ) t++, find( i );
          
    /*forn( i, cycl.size() )
    {
          forn( j, cycl[i].size() )
                cout << cycl[i][j] << " ";
          cout << endl;
    }*/
    
    /*--------new graph-------*/
    forn( i, cycl.size() )
    {
          forn( j, cycl[i].size() )
          {
                help[cycl[i][j]] = -1;
          }
    }
    forn( i, n ) gr[i].resize(0);
    forn( i, n )
    {
          if( help[i] == -1 ) continue;
          gr[help[i]].pb(i);
    }
    
    /*-------dp-----*/
    forn( i, n ) dp[i][0] = dp[i][1] = -200000;
    
    forn( i, n ) calk( i );
    
    forn( i, n ) dp1[i][0] = dp2[i][0] = dp[i][0], dp1[i][1] = dp2[i][1] = dp[i][1];
    int ans = 0;
    forn( i, cycl.size() )
    {
          if( cycl[i].size() == 2 )
          {
              ans += max( dp[cycl[i][0]][1] + dp[cycl[i][1]][1], dp[cycl[i][0]][0] + dp[cycl[i][1]][0] + 2 );
              continue;
          }
          
          imp1.pb( cycl[i][0] );
          forn( j, cycl[i].size() - 1 )
          {
                gr1[cycl[i][j]].pb( cycl[i][j + 1] );
          }
          
          imp2.pb( cycl[i][cycl[i].size() - 1] );
          gr2[cycl[i][cycl[i].size() - 1]].pb( cycl[i][0] );
          FOR( j, 1, cycl[i].size() - 3 )
          {
                gr1[cycl[i][j]].pb( cycl[i][j + 1] );
          }
    }
    memset( used, 0, n << 2 );
    forn( i, n )
    {
          if( gr1[i].size() != 0 ) calk2( i );
          if( gr2[i].size() != 0 ) calk2_( i );
    }
    
    forn( i, imp1.size() )
    {
          ans += max( max( dp1[imp1[i]][0], dp1[imp1[i]][1] ), max( dp2[imp2[i]][0], dp2[imp2[i]][1] ) );
    }
    cout << ans << endl;
    #ifdef FILE
    fclose(stdin);
    fclose(stdout);
    #else
    pause;
    #endif
    return 0;
}
