{Free Pascal}
program village;
var ff : text;
Needs,Ways,Prohibited: array[1..200000] of longint;
K,N,i,j,l,FreeMen : longint;
Procedure Init;
        begin
                assign(ff,'D:\Olimp\WORK\Maysak\village.in');
                reset(ff);
                readln(ff,N);
                for i := 1 to N do read(ff,Needs[i]);
                close(ff);
        end;

Function AllProhibited:boolean;
var a,b: longint;
        begin
                b := 0;
                for a:= 1 to N do
                        if Prohibited[a]<>0 then inc(b);
                if b = (N-1) then AllProhibited := True
                else AllProhibited := False;

        end;

Procedure MakeBond(A,B : longint);
        begin
                Ways[A] := B;
                Ways[B] := A;
                FreeMen := FreeMen - 2;
        end;

Procedure DeleteBond(A,B : longint);
        begin
                Ways[A] := 0;
                Ways[B] := 0;
                FreeMen := FreeMen + 2;
        end;

Procedure StepForward;
        begin
                for i:=1 to N do Prohibited[i] := 0;
                i := 0;
                repeat
                        inc(i);
                until Ways[i] = 0;

                j := i;
                repeat
                        inc(j);
                until (Ways[j] = 0) and (Prohibited[i]<>j);

                MakeBond(i,j);
        end;

Procedure StepBack;
        begin
                DeleteBond(i,j);
                Prohibited[i] := j;
        end;

Procedure Look;
var sub_k : longint;
        begin
                sub_k := 0;
                for i := 1 to N do
                        if Ways[i] = Needs[i] then inc(sub_k);
                if sub_k > k then k := sub_k;
        end;

Procedure Gen;
        begin
                if FreeMen = 0 then
                        begin
                                Look;
                                StepBack;
                        end
                Else if (FreeMen < N) and not(AllProhibited) then
                        begin
                                StepForward;
                                Gen;
                        end;

        end;



Procedure Run;
        begin
                k := 0;
                FreeMen := N;
                for i := 1 to N do Ways[i] := 0;
                StepForward;
                Gen;
        end;

Procedure Done;
        begin
                assign(ff, 'D:\Olimp\WORK\Maysak\village.out');
                rewrite(ff);
                Writeln(ff,K);
                Close(ff);
        end;
Begin
        Init;
        Run;
        Done;
End.
