/* GCC */
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

long find_mutual(vector<long> wish, bool* avail,long n)
{
    long i, quan=0;
    for(i=0; i<n; i++) {
        if((wish[wish[i]]==i)&&avail[i]&&avail[wish[i]]) {
            quan++;
            avail[i]=0;
            wish[i]=0;
        }
    }
    return quan;
}
long find_rest(vector<long> wish, bool* avail, long n)
{
    long i, quan=0;
    for(i=0; i<n; i++) {
        if(avail[i]&&avail[wish[i]]) {
            quan++;
            avail[i]=0;
            avail[wish[i]]=0;
        }
    }
    return quan;
}

int main()
{
    freopen("village.in", "r", stdin);
    freopen("village.out", "w", stdout);
    long n, counter, satisfied=0, temp;
    scanf("%ld", &n);
    bool *avail=new bool[n];
    vector<long> wish;
    wish.reserve(n);
    for(counter=0; counter<n; counter++) {
        scanf("%ld", &temp);
        wish.push_back(temp-1);
        avail[counter]=1;
    }
    satisfied+=find_mutual(wish, avail, n)*2;
    satisfied+=find_rest(wish, avail, n);
    printf("%ld\n", satisfied);
    return 0;
}
