/* GCC */
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define pb push_back
#define mp make_pair
#define ppb pop_back
#define sd second
#define fs first

#define inf 1000000007
#define nmax 200010
#define mmax 100010
#define eps 1e-7

int n, mark[nmax], ans, sz[nmax];
int top[nmax], ptr, color[nmax];
int a[nmax], d[nmax], col;
vector < int > g[nmax], gr[nmax];
vector < int > gn[nmax], gnr[nmax];

void use(int v)
{
	mark[v] = 1; 
	for(int i = 0; i < g[v].size(); ++i)
		if(!mark[g[v][i]])
			use(g[v][i]);
	top[++ptr] = v;
}

void rev(int v)
{
	mark[v] = 0; color[v] = col; ++sz[col];
	for(int i = 0; i < gr[v].size(); ++i)
		if(mark[gr[v][i]])
			rev(gr[v][i]);
}

int f(int v)
{
	d[v] = 0; mark[v] = 1;
	if(gnr[v].size() == 0)
		return 1;
	bool flag = false;
	for(int j = 0; j < gnr[v].size(); ++j)
	{
		flag |= f(gnr[v][j]);
		d[v] += d[gnr[v][j]];
	}
	if(flag & 1)
		++d[v];
	return flag ^ 1;
}

void bad_sol()
{
	for(int i = 0; i < 1 << n; ++i)
	{
		int mask = 0, cur = 0;
		for(int j = 0; j < n; ++j)
			if(i & (1 << j))
			{
				mask |= (1 << (a[j + 1] - 1));
				++cur;
			}
		if(mask + 1 == (1 << n))
			ans = max(ans, cur);
	}
	cout << ans << endl;
}

void good_sol()
{
	for(int i = 1; i <= n; ++i)
		if(!mark[i])
			use(i);
	for(int i = 1; i <= n; ++i)
		if(mark[top[n - i + 1]])
			++col, rev(top[n - i + 1]);
	for(int v = 1; v <= n; ++v)
		for(int j = 0; j < g[v].size(); ++j)
			if(color[v] != color[g[v][j]])
				gn[color[v]].pb(color[g[v][j]]), gnr[color[g[v][j]]].pb(color[v]);
	for(int i = 1; i <= col; ++i)
		if(!gn[i].size())
		{
			int v = i; ans += sz[v] / 2 + (sz[v] == 2);
			if(sz[v] % 2 == 0)
			{
				mark[v] = 1;
				for(int j = 0; j < gnr[v].size(); ++j)
					f(gnr[v][j]), ans += d[gnr[v][j]];
			}
			else
				f(v), ans += d[v]; 
		}
	cout << ans << endl;
}

int main()
{
	freopen("village.in", "r", stdin); freopen("village.out", "w", stdout);
	scanf("%d", &n);
	for(int i = 1; i <= n; ++i)
		scanf("%d", &a[i]), g[i].pb(a[i]), gr[a[i]].pb(i);
	/*if(n <= 20)
		bad_sol();
	else*/
		good_sol();
	//while(1);
}
